package jSimPack;

public class FutureEvent implements Comparable<FutureEvent>
{
    enum State
    {
        SCHEDULED,
        EXPIRED
    }

    final FutureEventListener handler;
    final SimTime when;
    final long label;
    final Object callback;
    private State state; 

    FutureEvent(FutureEventListener handler, SimTime when, long label, Object callback)
    {
	this.handler = handler;
	this.when = when;
	this.label = label;
	this.callback = callback;
        state = State.SCHEDULED;
    }

    public boolean isScheduled()
    {
        return state == State.SCHEDULED;
    }

    public void expire()
    {
        if (!isScheduled())
            throw new IllegalStateException("event is not scheduled: "+this);
        state = State.EXPIRED;
    }

    public int compareTo(FutureEvent e)
    {
        int timeCompare = when.compareTo(e.when);
        if (timeCompare != 0)
            return timeCompare;
        if (label < e.label)
            return -1;
        if (label > e.label)
            return 1;
        return 0;
    }

    @Override
    public String toString() {
        return "Time:" + when + "  Label:" + label + " Callback" + callback;
    }
}
