package simulator.elevatormodules;

import java.util.BitSet;
import simulator.payloads.CanMailbox;
import simulator.payloads.translators.CanPayloadTranslator;

/**
 * @author Justin Ray
 */
public class VarIntegerCanTranslator extends CanPayloadTranslator {

    String name;

    VarIntegerCanTranslator(CanMailbox p, int expectedMask, String name, int byteSize) {
        super(p, byteSize, expectedMask);
        this.name = name;
    }
    
    //required for reflection
    public void set(int value) {
        setValue(value);
    }


    public int getValue() {
        return getIntFromBitset(mailbox.getMessagePayload(), 0, byteSize * 8);
    }

    public void setValue(int position) {
        BitSet b = mailbox.getMessagePayload();
        addIntToBitset(b, position, 0, byteSize * 8);
        mailbox.setMessagePayload(b, byteSize);
    }

    @Override
    public String payloadToString() {
        return name + " = " + getValue();
    }
}
