/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package simulator.elevatormodules.passenger;

import simulator.elevatormodules.ButtonLight;
import simulator.elevatormodules.ChangeMachine;
import simulator.elevatormodules.CoinReturnButton;
import simulator.elevatormodules.SodaButton;
import simulator.elevatormodules.VendActuator;
import simulator.framework.Harness;

/**
 * This class provides access to modules which a passenger interacts
 * with to affect the system state.  It also provides a callback interface
 * (through receivePassengerEvent) for the modules to generate events that
 * the passengers can react to.
 *
 * @author justinr2
 */
public class PassengerControl {

    public final SodaButton[] sodaButtons;
    public final ButtonLight[] buttonLights;
    public final CoinReturnButton coinReturnButton;
    public final ChangeMachine changeMachine;
    public final VendActuator vendActuator;

    public PassengerControl(SodaButton[] sodaButtons, ButtonLight[] buttonLights, CoinReturnButton coinReturnButton, ChangeMachine changeMachine, VendActuator vendActuator) {
        this.sodaButtons = sodaButtons;
        this.buttonLights = buttonLights;
        this.coinReturnButton = coinReturnButton;
        this.changeMachine = changeMachine;
        this.vendActuator = vendActuator;
    }

    private Passenger currentPassenger = null;
    void setCurrentPassenger(Passenger currentPassenger) {
        this.currentPassenger = currentPassenger;

    }

    public void receivePassengerEvent(PassengerEvent e) {
        if (currentPassenger == null) {
            Harness.log("PassengerControl", "Warning, PassengerEvent occured but currentPassenger is null: " + e);
            return;
        }
        currentPassenger.receivePassengerEvent(e);

    }
}
