/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package simulator.framework;

import simulator.framework.CANNetwork.CanConnection;
import simulator.framework.PhysicalNetwork.PhysicalConnection;

/**
 *
 * @author kamikasee
 */
public abstract class Controller extends Networkable implements TimeSensitive {

    protected final CanConnection canInterface = Harness.getCANNetwork().getCanConnection();
    protected final PhysicalConnection physicalInterface = Harness.getPhysicalNetwork().getConnection();
    protected final Timer timer = new Timer(this);
    
    protected boolean verbose = false;
    protected String name;

    
    public Controller(String name, boolean verbose) {
        this.verbose = verbose;
        this.name = name;
    }

    @Override
    public String toString() {
        return name;
    }
    
    

    protected void log(Object... msg) {
        if (!verbose) {
            return;
        }
        Harness.log(name, msg);
    }
}
