package simulator.framework;

import jSimPack.FutureEvent;
import jSimPack.FutureEventListener;
import jSimPack.SimTime;
import simulator.payloads.*;



/**
 * This class implements timer functionality for the system queue.  Events
 * scheduled on the system queue are not randomized and always occur before 
 * events in the simulation queue scheduled at the same time.  
 * 
 * This timer may not be used in any code written by a student.
 * @author justinr2
 */
public class SystemTimer extends AbstractTimer {

    public SystemTimer(TimeSensitive handler) {
        super(handler);
    }
    
    @Override
    protected FutureEvent scheduleEvent(FutureEventListener event, SimTime timeInterval, Object data) {
        return Harness.scheduleNonsimulationEvent(event, timeInterval, data);
    }

    @Override
    protected boolean cancelEvent(FutureEvent event, boolean deleteNow) {
        return Harness.cancelNonsimulationEvent(event, deleteNow);
    }
    
}
